#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <argp.h>
#include <string.h>
const char *argp_program_version = "basex-1.0";
const char *argp_program_bug_address = "zoeurk@gmail.com";
static struct argp_option
options[] = { 	{"infile",'i', "FILE",0, "input file (- for stdin)", 0 },
		{"output", 'o', "FILE", 0, "output file (- for stdout)", 0},
		{"decode",'d', NULL ,0,"decode (default is to encode)",0},
		{"base", 'b', "BASE",0, "select base BIN,16,32,32hex,64,64url",0},
		{"len", 'l', "BUFFER",0, "Buffer size reading streams",0},
		{0}
	};
/*static char args_doc[] = "";*/
struct arguments
{	int infile, outfile, dec, base;
	ssize_t buflen;
	void *buf;
}arguments;
struct stream{
	int	fd, ___;
	ssize_t	read, get, let;
	void	*buffer;
}stream;
struct basex{
	char *input;
	size_t inlen;
	char *output;
	size_t outlen;
	int indef, outdef;
	char *base;
	int dec;
	int padding;
	ssize_t (*lenbuf)(size_t,int);
	int (*splitto)(char *,char *,ssize_t,char *);
	int (*convertfrom)(char *,char *,size_t,int);
	void (*joinfrom)(char *,char *,size_t);
}basex;
struct string{
	char *buffer;
	size_t len;
}string;
char *base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
char *base64url = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_=";
char *base32 = "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567=";
char *base32hex = "0123456789ABCDEFGHIJKLMNOPQRSTUV=";
char *base16 = "0123456789ABCDEF";
char *binary = "01";
ssize_t
lenbuf(size_t inlen,int inblock)
{	ssize_t n;
	for(	n = inlen;
		n%inblock!=0;
		n++
	);
	return n;
}
#define read_buffer(jump)\
	for(	i = len,\
		j = i%jump,\
		i -=j,\
		in = (unsigned char *)input,\
		out = (unsigned char *)output;\
		i != 0;\
		i -= jump,\
		in += jump\
	)
#define read_end_buffer(jump) for( k=0,l=jump;k<=j;k++,l--)
int
splittobinary(char *input, char *output, ssize_t len,char *base)
{	unsigned char *in,*out;
	size_t l;
	for(	l = len,
		out = (unsigned char *)output,
		in = (unsigned char *)input;
		l !=0;
		l--,
		in++
	){	*out = base[(*in&128)>>7],out++;
		*out = base[(*in&64)>>6],out++;
		*out = base[(*in&32)>>5],out++;
		*out = base[(*in&16)>>4],out++;
		*out = base[(*in&8)>>3],out++;
		*out = base[(*in&4)>>2],out++;
		*out = base[(*in&2)>>1],out++;
		*out = base[(*in&1)],out++;
	};
	return 0;
}
int
splitto16bits(char *input, char *output, ssize_t len,char *base)
{	unsigned char *in, *out;
	ssize_t i;
	for(	i = len,
		in = (unsigned char *)input,
		out = (unsigned char *)output;
		i != 0;
		i--,
		in++
	){	*out = base[*in >>4],out++;
		*out = base[(unsigned char)(*in <<4)>>4],out++;
	};
	return 0;
}
int
splitto32bits(char *input, char *output, ssize_t len,char *base)
{	unsigned char *in,*out;
	ssize_t i;
	int j = 0, l = 0;
	read_buffer(5)
	{	
		*out = base[in[0]>>3],out++;
		*out = base[(((unsigned char)(in[0]<<5)>>5)<<2) | (unsigned char)(in[1]>>6)],out++;
		*out = base[((unsigned char)(in[1]<<2)>>3)],out++;
		*out = base[((unsigned char)(in[1]<<7)>>3) | (unsigned char)(in[2]>>4)],out++;
		*out = base[((unsigned char)(in[2]<<4)>>3) | (unsigned char)(in[3]>>7)],out++;
		*out = base[((unsigned char)(in[3]<<1)>>3)],out++;
		*out = base[((unsigned char)(in[3]<<6)>>3) | (unsigned char)(in[4]>>5)],out++;
		*out = base[(unsigned char)(in[4]<<3)>>3],out++;
	}
	if(j==0)
		return 0;
	switch(j)
	{	case 1:	out[0] = base[in[0]>>3];
			out[1] = base[(((unsigned char)(in[0]<<5)>>5)<<2) | (unsigned char)(in[1]>>6)];
			l = 6;
			break;
		case 2:	out[0] = base[in[0]>>3];
			out[1] = base[(((unsigned char)(in[0]<<5)>>5)<<2) | (unsigned char)(in[1]>>6)];
			out[2] = base[((unsigned char)(in[1]<<2)>>3)];l = 4;
			out[3] = base[((unsigned char)(in[1]<<7)>>3) | (unsigned char)(in[2]>>4)];
			l = 4;
			break;
		case 3: out[0] = base[in[0]>>3];
			out[1] = base[(((unsigned char)(in[0]<<5)>>5)<<2) | (unsigned char)(in[1]>>6)];
			out[2] = base[((unsigned char)(in[1]<<2)>>3)];l = 4;
			out[3] = base[((unsigned char)(in[1]<<7)>>3) | (unsigned char)(in[2]>>4)];
			out[4] = base[((unsigned char)(in[2]<<4)>>3) | (unsigned char)(in[3]>>7)];
			l = 3;
			break;
		case 4:	out[0] = base[in[0]>>3];
			out[1] = base[(((unsigned char)(in[0]<<5)>>5)<<2) | (unsigned char)(in[1]>>6)];
			out[2] = base[((unsigned char)(in[1]<<2)>>3)];
			out[3] = base[((unsigned char)(in[1]<<7)>>3) | (unsigned char)(in[2]>>4)];
			out[4] = base[((unsigned char)(in[2]<<4)>>3) | (unsigned char)(in[3]>>7)];
			out[5] = base[((unsigned char)(in[3]<<1)>>3)];
			out[6] = base[((unsigned char)(in[3]<<6)>>3) | (unsigned char)(in[4]>>5)];
			out[7] = base[(unsigned char)(in[4]<<3)>>3];
			l = 1;
			break;
	}
	return l;
}
int
splitto64bits(char *input, char *output, ssize_t len,char *base)
{	unsigned char *in,*out;
	ssize_t i;
	int	j = 0,k,l;
	read_buffer(3)
	{	*out = base[in[0] >>2],out++;
		*out = base[(((unsigned char)(in[0] <<6)>>6)<<4) | (unsigned char)((in[1]>>4))],out++;
		*out = base[(((unsigned char)(in[1]<<4)>>4)<<2) | (unsigned char)(in[2]>>6)],out++;
		*out = base[((unsigned char)(in[2]<<2)>>2)],out++;
		/***************************************************************/
	}
	if(j==0)
		return 0;
	read_end_buffer(4)
		switch(k)
		{	case 0: out[0] = base[in[0] >>2];break;
			case 1: out[1] = base[(((unsigned char)(in[0] <<6)>>6)<<4) | (unsigned char)((in[1]>>4))];break;
			case 2: out[2] = base[(((unsigned char)(in[1]<<4)>>4)<<2) | (unsigned char)(in[2]>>6)];break;
			case 3: out[3] = base[((unsigned char)(in[2]<<2)>>2)];break;
		}
	return l;
}
#undef read_buffer
int 
convertfrom(char *input,char *base,size_t len,int inblock)
{	size_t l=len;
	int i;
	char *s = NULL,*in;
	if(len%inblock) return 1;
	for(	in = input; l > 0;
		*in = (*in == '=') ? 0 : i,
		in++, l--

	)for(	s = base,i=0;
		*s!=*in && s != 0;
		s++, i++
	);
	if(*s == 0)return 2;
	return 0;
}
void
joinfrombinary(char *input, char *output, size_t len)
{	unsigned char *in,*out;
	size_t l;
	for(	l = len,
		out = (unsigned char *)output,
		in = (unsigned char *)input;
		l !=0; l-= 8, in+=8
	){	*out = (unsigned char)((in[0]<<7)| (in[1]<<6) | (in[2]<<5) | (in[3]<<4) | (in[4]<<3) | (in[5]<<2) | (in[6]<<1) | in[7]), out++;
	}
}
void
joinfrom16bits(char *input, char *output, size_t len)
{	unsigned char *in, *out;
	ssize_t i;
	for(	in = (unsigned char *)input,
		out = (unsigned char *)output,
		i = len;
		i > 0; i-=2, in+=2
	){	*out = (in[0]<<4) | in[1],out++;
	}
}
void
joinfrom32bits(char *input, char *output, size_t len)
{	unsigned char *in, *out;
	ssize_t i;
	for(	in = (unsigned char *)input,
		out = (unsigned char *)output,
		i = len; 
		i > 0; in += 8, i -= 8
	){	
		*out = (in[0]<<3) | (in[1] >>2) ,out++;
		*out = (in[1]<<6) | (in[2] << 1) | (in[3] >>4),out++;
		*out = (in[3]<<4) | (in[4]>>1),out++;
		*out = (in[4]<<7) | (in[5]<<2) | in[6]>>3,out++;
		*out = (in[6]<<5) | in[7],out++;
	}
}
void
joinfrom64bits(char *input, char *output, size_t len)
{	unsigned char *in, *out;
	ssize_t i;
	for(	in = (unsigned char *)input,
		out = (unsigned char *)output,
		i = len;
		i > 0; i -= 4, in += 4
	){
		*out = (in[0]<<2) | (in[1]>>4),out++;
		*out = (in[1]<<4) | (in[2]>>2),out++;
		*out = (in[2]<<6) | in[3],out++;
	}
}
enum bases
{	BINARY,
	BASE16,
	BASE32,
	BASE32hex,
	BASE64,
	BASE64url
}bases;
void
inittobase(struct basex *b,int base)
{
	switch(base)
	{	case BINARY:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 1;
			b->outdef = 8;
			b->base = binary;
			b->lenbuf = &lenbuf;
			b->splitto = &splittobinary;
			break;
		case BASE16:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 1;
			b->outdef = 2;
			b->base = base16;
			b->lenbuf = &lenbuf;
			b->splitto = &splitto16bits;
			break;
		case BASE32:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 5;
			b->outdef = 8;
			b->base = base32;
			b->lenbuf = &lenbuf;
			b->splitto = &splitto32bits;
			break;
		case BASE32hex:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 5;
			b->outdef = 8;
			b->base = base32hex;
			b->lenbuf = &lenbuf;
			b->splitto = &splitto32bits;
			break;
		case BASE64:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 3;
			b->outdef = 4;
			b->base = base64;
			b->lenbuf = &lenbuf;
			b->splitto = &splitto64bits;
			break;
		case BASE64url:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 3;
			b->outdef = 4;
			b->base = base64url;
			b->lenbuf = &lenbuf;
			b->splitto = &splitto64bits;
			break;
	}
}
void
initfrombase(struct basex *b,int base)
{
	switch(base)
	{	case BINARY:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 8;
			b->outdef = 1;
			b->base = binary;
			b->lenbuf = &lenbuf;
			b->convertfrom = &convertfrom;
			b->joinfrom = &joinfrombinary;
			break;
		case BASE16:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 2;
			b->outdef = 1;
			b->base = base16;
			b->lenbuf = &lenbuf;
			b->convertfrom = &convertfrom;
			b->joinfrom = &joinfrom16bits;
			break;
		case BASE32:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 8;
			b->outdef = 5;
			b->base = base32;
			b->lenbuf = &lenbuf;
			b->convertfrom = &convertfrom;
			b->joinfrom = &joinfrom32bits;
			break;
		case BASE32hex:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 8;
			b->outdef = 5;
			b->base = base32hex;
			b->lenbuf = &lenbuf;
			b->convertfrom = &convertfrom;
			b->joinfrom = &joinfrom32bits;
			break;
		case BASE64:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 4;
			b->outdef = 3;
			b->base = base64;
			b->lenbuf = &lenbuf;
			b->convertfrom = &convertfrom;
			b->joinfrom = &joinfrom64bits;
			break;
		case BASE64url:
			b->output = NULL;
			b->outlen = 0;
			b->indef = 4;
			b->outdef = 3;
			b->base = base64url;
			b->lenbuf = &lenbuf;
			b->convertfrom = &convertfrom;
			b->joinfrom = &joinfrom64bits;
			break;
	}
}
static error_t
parse_opt
	(int key, char *arg, struct argp_state *state)
{	struct arguments *arguments = state->input;
	char *nobases[6] = {"BIN","16","32","32hex","64","64url"};
	switch(key)
	{	case 'i': if(*arg == '-')
			  {	arguments->infile = STDIN_FILENO;
			  }
			  else
			  {	if((arguments->infile = open(arg,O_RDONLY))<0)
			  	{	fprintf(stderr,"I can not open %s\n",arg);
					exit(errno);
				}
  			 }
			  break;
		case 'o': if(*arg == '-')
			  {	arguments->outfile = STDOUT_FILENO;
			  }
			  else
			  {	if((arguments->outfile = open(arg,O_WRONLY))<0)
			  	{	fprintf(stderr,"I can not open %s\n",arg);
					exit(errno);
				}

			  }
			  break;
		case 'd': arguments->dec = 1;
			  break;
		case 'b': for( 	arguments->base = 0;
				arguments->base<6 && 
					strncmp(nobases[arguments->base],arg,strlen(arg))!=0;
				arguments->base++);
			  if(arguments->base == 6)
			  {	fprintf(stderr,"Unknow base: %s\n",arg);
			  	exit(EXIT_FAILURE);
			  }
			  break;
		case 'l': arguments->buflen = atoi(arg); break;
		default:if(arguments->buf == NULL && arg!=NULL)
			{	arguments->buf = arg;
				return 0;
			}
			break;
	}
	return 0;
}
union convert{
	struct string str;
	struct basex b;
}convert;
#define BUFFER 512
void
encoding(struct basex *b,int base)
{	char *s;
	inittobase(b,base);
	b->outlen = b->outdef*(*b->lenbuf)(b->inlen,b->indef)/b->indef;
	if((b->output = calloc(b->outlen,sizeof(char)))==NULL)
	{ 	fprintf(stderr,"can not alloc memory.\n");
		exit(EXIT_FAILURE);
	}
	b->padding = (*b->splitto)(b->input,b->output,b->inlen,b->base);
	if(b->padding)
	for( 	s = b->output + b->outlen-1;
		b->padding > 0;
		s[0] = '=',
		s--, b->padding--
	);
}
void
decoding(struct basex *b,int base)
{
	initfrombase(b,base);
	b->outlen = b->outdef*(*b->lenbuf)(b->inlen,b->indef)/b->indef;
	if((b->output = calloc(b->inlen,sizeof(char))) == NULL)
	{	fprintf(stderr,"Can not alloc memory.\n");
		exit(EXIT_FAILURE);
	}
	if((*b->convertfrom)(b->input,b->base,b->inlen,b->indef)!=0)
	{	fprintf(stderr,"Can not convert:Bad base maybe\n");
		free(b->output);
		exit(EXIT_FAILURE);
	}
	(*b->joinfrom)(b->input,b->output,b->inlen);
}
void (*converting[2])(struct basex *b,int base) = {&encoding,&decoding};
void (*streaminitbase[2])(struct basex *b, int base) = {&initfrombase,&inittobase};
static struct argp argp = {options,parse_opt,NULL,NULL,NULL,NULL,NULL};
int 
main(int argc, char **argv)
{	static struct arguments arg = {0, 1, 0, BASE64, 512,NULL};
	union convert c = {{NULL,0}};
	argp_parse(&argp,argc,argv,0,0,&arg);
	c.b.dec=arg.dec;
	if(arg.buf != NULL)
	{	c.str.buffer = arg.buf;
		c.str.len = strlen(c.str.buffer);
		(*converting[c.b.dec !=0])(&c.b,arg.base);

		write(0,c.b.output,c.b.outlen);
		free(c.b.output);
	}
	else
	{	(*streaminitbase[c.b.dec!=0])(&c.b,arg.base);
		c.b.inlen = c.b.outdef*(*c.b.lenbuf)(arg.buflen,c.b.indef);
		if((arg.buf=calloc(c.b.inlen*sizeof(char)+sizeof(struct stream),sizeof(char))) == NULL)
		{	fprintf(stderr,"alloc failled.");
			if(arg.infile != STDIN_FILENO) close(arg.infile);
			if(arg.outfile != STDOUT_FILENO) close(arg.outfile);
			exit(errno);
		}
		((struct stream *)arg.buf)->buffer = arg.buf + sizeof(struct stream);
		((struct stream *)arg.buf)->fd = arg.infile;
		((struct stream *)arg.buf)->get = c.b.inlen;
		((struct stream *)arg.buf)->let = 0;
		c.b.input = ((struct stream *)arg.buf)->buffer;
		while(	(((struct stream *)arg.buf)->read
			= read(	((struct stream *)arg.buf)->fd,
				((struct stream *)arg.buf)->buffer,
				((struct stream *)arg.buf)->get)
			)>0
		)
		{	c.b.inlen = ((struct stream *)arg.buf)->read;
			c.b.outlen = (*c.b.lenbuf)(c.b.inlen,c.b.indef);
			(*converting[c.b.dec !=0])(&c.b,arg.base);
			write(arg.outfile,c.b.output,c.b.outlen);
			memset(c.b.input,0,c.b.inlen);
			free(c.b.output);
		}
		free(arg.buf);
	}
	if(arg.infile != STDIN_FILENO) close(arg.infile);
	if(arg.outfile != STDOUT_FILENO) close(arg.outfile); else printf("\n");
	return 0;
}
